#ifdef WIN32
#pragma comment(lib, "SDL.lib")
#pragma comment(lib, "SDLmain.lib")
#pragma comment(lib, "SDL_mixer.lib")
#endif

#include <stdlib.h> //include files
#include <stdio.h>
#include <string>
#include <time.h>
#include <math.h>
#include "SDL_mixer.h"
#include "font.h"
#include "SDL.h"

//The following is for creating new objects in a linklist and deleting objects
#define LINK(link, first, last) \
if (!(first))                   \
  (first) = (link);             \
else                            \
  (last)->next = (link);        \
(link)->next = NULL;            \
(link)->prev = (last);          \
(last) = (link);				
#define UNLINK(link, first, last) \
if (!(link)->prev)                \
  (first) = (link)->next;         \
else                              \
  (link)->prev->next = (link)->next;  \
if (!(link)->next)                \
  (last) = (link)->prev;          \
else                              \
  (link)->next->prev = (link)->prev;
//define the max to each side of the screen
#define MAX_LEFT 0
#define MAX_TOP 0
#define MAX_RIGHT 480 //480 because of the black area which you cant move to
#define MAX_BOTTOM 480

//any function declarations
void checkit(void);
void exit(void);
void kill(void);
void gameover(void);

//Shots on screen, score
int i=0, sos=0, score=0, ekilled=0, enemies=0, shooting=1, conts=2;
int nextswitch = 45; //use for blinking
//This tells you if you are alive or dead. dead2 and 3 
//will be used for explosion animation
typedef enum
{
  ALIVE, DEAD1, DEAD2, DEAD3
} PlaneState;
//gamestate struct

typedef enum
{
  INTRO, PLAYING, OVER
} GameState;
//Creates your plane as a struct, easier to track values
struct Plane
{
  int iX, iY;
  int iHealth;
  int lives;
  PlaneState pState;
};
//linklist for the bullets, players and enemies
struct Shot
{
  Shot *prev, *next;
  int iX, iY;
};
//structure to hold enemy state
typedef enum
{
  ENEMY_ALIVE, ENEMY_DEAD1, ENEMY_DEAD2, ENEMY_DEAD3
} EnemyState;
//linklist for the enemy, contains the needed enemy values
struct Enemy
{
  Enemy *prev, *next;
  int iX, iY;
  int iHealth;
  int iSpeed;
  int iShot;
  int iPicture;
  EnemyState eState;
};

//initialize the first and last parts of each linklist, create states
Shot *pShotFirst, *pShotLast;
Enemy *enemyFirst, *enemyLast;
Shot *eShotFirst, *eShotLast;
Plane plane;
GameState gState;

//create the SDL images and font values
SDL_Surface *back, *image, *shot, *enemy, *boom1, *boom2, *boom3, *intro;
SDL_Surface *screen;
SDLFont *font1;
SDLFont *font2;
Mix_Music *introm, *level1, *dead;
Mix_Chunk *shots;

int InitImages() //This function loads bitmaps into their variable
 {
  back = SDL_LoadBMP("bg.bmp");
  image = SDL_LoadBMP("image.bmp");
  shot = SDL_LoadBMP("1.bmp");
  enemy = SDL_LoadBMP("enemy.bmp");
  boom1 = SDL_LoadBMP("boom1.bmp");
  boom2 = SDL_LoadBMP("boom2.bmp");
  boom3 = SDL_LoadBMP("boom3.bmp");
  intro = SDL_LoadBMP("intro.bmp");
  return 0;
 }

 int InitMusic() 
 {
  introm = Mix_LoadMUS("data/sound/balofdkn.xm");
  dead = Mix_LoadMUS("data/sound/ate.xm");
  level1 = Mix_LoadMUS("data/sound/tfplanet.xm");
 shots = Mix_LoadWAV("data/sound/shot.wav");
  return 0;
 }
//used to draw the whole image at a certain x and y value
void DrawIMG(SDL_Surface *img, int x, int y)
 {
  SDL_Rect dest;
  dest.x = x;
  dest.y = y;
  SDL_BlitSurface(img, NULL, screen, &dest);
 }
//used to draw parts of an image or whole at x and y, with height and width
void DrawIMG(SDL_Surface *img, int x, int y,
                                int w, int h, int x2, int y2)
 {
  SDL_Rect dest;
  dest.x = x;
  dest.y = y;
  SDL_Rect dest2;
  dest2.x = x2;
  dest2.y = y2;
  dest2.w = w;
  dest2.h = h;
  SDL_BlitSurface(img, &dest2, screen, &dest);
 }

//just a function to draw only the backgrounds.
void DrawBG()
 {
  if(gState==PLAYING)
   DrawIMG(back, 0, 0);
  if(gState==INTRO)
   DrawIMG(intro, 0, 0);
 }
//draws parts of game depending on the state. Cluttered at the moment
//it loops through the linklists to draw every instance of each list
//and also draws the background where the old instance was
//At this moment it handles all of the drawing, no matter what the
//gamestate is.
void DrawScene()
{
 if(gState==PLAYING){
  DrawIMG(back, plane.iX-3, plane.iY-3, 40, 40, plane.iX-3, plane.iY-3);
  for (Shot *pShot = pShotFirst; pShot; pShot = pShot->next)
  {
   DrawIMG(back, pShot->iX-2, pShot->iY-2, 10, 10, pShot->iX-2, pShot->iY-2);
  }
  for (Shot *eShot = eShotFirst; eShot; eShot = eShot->next)
  {
   DrawIMG(back, eShot->iX-2, eShot->iY-2, 10, 10, eShot->iX-2, eShot->iY-2);
  }
  for (Enemy *pEnemy = enemyFirst, *pENext; pEnemy; pEnemy = pENext)
  {
	pENext = pEnemy->next;
	DrawIMG(back, pEnemy->iX-2, pEnemy->iY-2, 40, 35, pEnemy->iX-2, pEnemy->iY-2);
  }
  if(plane.pState==ALIVE){
	  DrawIMG(image, plane.iX, plane.iY);}
  for (Shot *pShot = pShotFirst; pShot; pShot = pShot->next)
  {
    pShot->iY-=8;
    DrawIMG(shot, pShot->iX, pShot->iY);
  }
  for (Shot *eShot = eShotFirst; eShot; eShot = eShot->next)
  {
    eShot->iY+=5;
    DrawIMG(shot, eShot->iX, eShot->iY);
  }
  for (Enemy *pEnemy = enemyFirst, *pENext; pEnemy; pEnemy = pENext)
  {
	  pENext = pEnemy->next;
	  if(pEnemy->eState==ENEMY_ALIVE){    
	pEnemy->iY+=pEnemy->iSpeed;
	DrawIMG(enemy, pEnemy->iX, pEnemy->iY);}
	if(pEnemy->eState==ENEMY_DEAD3){
	DrawIMG(boom3, pEnemy->iX, pEnemy->iY);
	DrawIMG(back, pEnemy->iX-2, pEnemy->iY-2, 40, 35, pEnemy->iX-2, pEnemy->iY-2);
	ekilled++;}
    if(pEnemy->eState==ENEMY_DEAD2){
	DrawIMG(boom2, pEnemy->iX, pEnemy->iY);pEnemy->eState=ENEMY_DEAD3;}
	if(pEnemy->eState==ENEMY_DEAD1){
	DrawIMG(boom1, pEnemy->iX, pEnemy->iY);pEnemy->eState=ENEMY_DEAD2;}
	

  }
 drawString(screen,font1,495,450,"StarFighter");
  DrawIMG(back, 505, 0, 120, 85, 505, 0);
  drawString(screen,font2,505,1,"Score: %d",score);
  drawString(screen,font2,505,16,"Health: %d",plane.iHealth);
  for(i=0;i<plane.lives;i++)
    DrawIMG(image, 505+(i*33), 32);
  if(plane.pState==DEAD1){
	  drawString(screen,font1,50,260,"Enter to Continue, ESC to quit.");
  }
  }
 else if(gState==INTRO)
 {
	if(nextswitch>15) //this handles the blinking text in the intro
       drawString(screen,font1,10,430,"Press Enter");
    if(nextswitch <= 15)
		DrawIMG(intro, 0, 0);
    if(nextswitch==0)
	   nextswitch=45;
	nextswitch--; 
    
 }
  SDL_Flip(screen);
}

int main(int argc, char *argv[])
{
 Uint8* keys;
 srand(time(NULL));
 int  randnum=0, i=0;
 int done=0;
 long ticks; //ticks is used for frames per second
 
 //This fills the first and last values in the linklists
 pShotFirst = pShotLast = NULL;
 enemyFirst = enemyLast = NULL;
 eShotFirst = eShotLast = NULL;
 //initialize the plane values and the gamestate
 plane.iX=300; plane.iY=420; plane.iHealth=50; plane.pState=DEAD1;
 plane.lives=1;
 gState=INTRO;
 //Initializing some SDL stuff and error message if unable to
 if ( SDL_Init(SDL_INIT_AUDIO|SDL_INIT_VIDEO) < 0 )
  {
    printf("Unable to init SDL: %s\n", SDL_GetError());
    exit(1);
  }
 atexit(SDL_Quit);
 if(Mix_OpenAudio(44100, AUDIO_S16SYS, 2, 2048) < 0)
  {
    printf("Warning: Couldn't set 44100 Hz 16-bit audio\n- Reason: %s\n",
							SDL_GetError());
  }

 //initialize the screen for SDL and if you can't then error
 screen=SDL_SetVideoMode(640,480,32,SDL_HWSURFACE|SDL_DOUBLEBUF);
 if ( screen == NULL )
  {
    printf("Unable to set 640x480 video: %s\n", SDL_GetError());
    exit(1);
  }
  InitMusic();
  InitImages();//initializes the images, loads them into their variable
  //sets transparency on image, will have own function later
 SDL_SetColorKey(image, SDL_SRCCOLORKEY,
                           SDL_MapRGB(image->format, 255, 0, 255));
 SDL_SetColorKey(enemy, SDL_SRCCOLORKEY, 
                           SDL_MapRGB(enemy->format, 255, 0, 255));
 SDL_SetColorKey(boom1, SDL_SRCCOLORKEY, 
                           SDL_MapRGB(boom1->format, 255, 0, 255));
 SDL_SetColorKey(boom2, SDL_SRCCOLORKEY, 
                           SDL_MapRGB(boom2->format, 255, 0, 255));
 SDL_SetColorKey(boom3, SDL_SRCCOLORKEY, 
                           SDL_MapRGB(boom3->format, 255, 0, 255));

 DrawBG(); //draw current background
 font1 = initFont("data/font1"); //initialize fonts
 font2 = initFont("data/font2",1,1,0);

  while(done == 0)
  {
	ticks = SDL_GetTicks(); //getticks gets time since SDL started
    SDL_Event event;

    while ( SDL_PollEvent(&event) ) //checks for exiting
    {
      if ( event.type == SDL_QUIT )  {exit();done = 1;  }

      if ( event.type == SDL_KEYDOWN )
      {
        if ( event.key.keysym.sym == SDLK_ESCAPE ) { done = 1; }
      }
	}
keys = SDL_GetKeyState(NULL);
//have to be alive to control, I'd say these are self explanatory
if(plane.pState==ALIVE){ 
if ( keys[SDLK_UP] ) { plane.iY -= 3; if (plane.iY<=0){plane.iY=0;}}
    if ( keys[SDLK_DOWN] ) { plane.iY += 3; if (plane.iY>=450){plane.iY=450;}}
    if ( keys[SDLK_LEFT] ) { plane.iX -= 3; if (plane.iX<=0){plane.iX=0;}}
    if ( keys[SDLK_RIGHT] ) { plane.iX += 3; if (plane.iX>=468){plane.iX=468;}}
	if ( keys[SDLK_RETURN] ) {kill();}
//hitting space actually creates a new shot
	if ( keys[SDLK_SPACE] && sos<=15 && shooting==1) {sos+=1; shooting++;
		  Shot *pNew;
		  pNew = new Shot;
          pNew->iX = plane.iX+14;
          pNew->iY = plane.iY-2;
		  LINK(pNew, pShotFirst, pShotLast);
		  Mix_PlayChannel(0, shots, 0);
	}
}
//when dead run this code, this is so you can continue
if(plane.pState==DEAD1 && gState==PLAYING){ 
 if ( keys[SDLK_RETURN] ) {
   plane.iHealth=50;
   kill(); score=0;
   plane.iX=300; plane.iY=420;
   plane.pState=ALIVE; 
   //Mix_FadeOutChannel(-1, 1000);
   //Mix_FadeOutMusic(1000);
   //SDL_Delay(1000);
   Mix_HaltMusic();
   DrawIMG(back, 0, 0);
 }
 if ( keys[SDLK_RCTRL] ) {  //FOR TESTING PURPOSES!!!!!!!!!!!!!!!!!!
   plane.iHealth=10;
   kill(); score=0;
   plane.iX=300; plane.iY=420;
   plane.pState=ALIVE; 
   //Mix_FadeOutChannel(-1, 1000);
   //Mix_FadeOutMusic(1000);
   //SDL_Delay(1000);
   Mix_HaltMusic();
   DrawIMG(back, 0, 0);
 }
}
//this is the key input for the intro part, so you can start
//i still have my testing code in here
if(gState==INTRO){
 if ( keys[SDLK_RETURN] ) {
   gState=PLAYING;
   plane.pState=ALIVE; 
   kill();
   DrawBG();
   //Mix_FadeOutChannel(-1, 1000);
   //Mix_FadeOutMusic(1000);
   //SDL_Delay(1000);
   Mix_HaltMusic();
 }
 if ( keys[SDLK_RCTRL] ) { //FOR TESTING PURPOSES!!!!!!!!!!!!!!!!!!
   gState=PLAYING;
   plane.pState=ALIVE; 
   plane.iHealth=10;
   kill();
   DrawBG();
   //Mix_FadeOutChannel(-1, 1000);
   //Mix_FadeOutMusic(1000);
   //SDL_Delay(1000);
   Mix_HaltMusic();
 }
}
if(!Mix_PlayingMusic() && gState==PLAYING && plane.pState==ALIVE)
    {
	  Mix_PlayMusic(level1, 0);
    }
if(!Mix_PlayingMusic() && gState==INTRO)
    {
      Mix_PlayMusic(introm, 0);
    }
if(!Mix_PlayingMusic() && gState==PLAYING && plane.pState==DEAD1)
    {
      Mix_PlayMusic(dead, 0);
    }
//this is where you determine if a new enemy appears
//it should only allow 6 on screen, but for some reason I think its more
//it will also set all the values of the enemy
randnum=rand()%100;
if(randnum<=0 && enemies<7){Enemy *eNew;
      eNew = new Enemy;
      eNew->iX = rand()%MAX_RIGHT;
      eNew->iY = MAX_TOP+9;
      eNew->iHealth = 10;
	  eNew->eState=ENEMY_ALIVE;
      eNew->iPicture = 0;
      eNew->iSpeed = rand()%2+1;
	  LINK(eNew, enemyFirst, enemyLast);
      enemies++;}
//finally, redraw scene and then check for all collision
//or things off screen, I think the order should be switched
 DrawScene();checkit();
 //don't run again until the required time to be 60 frames a sec is hit
	  while (SDL_GetTicks() < (ticks + 12)){}
	  if (shooting<10 && shooting!=1)shooting++;
	  else if (shooting>=10)shooting=1;  }
 freeFont(font1);
 freeFont(font2);
 //Mix_FadeOutChannel(-1, 1000);
 //Mix_FadeOutMusic(1000);
 //SDL_Delay(1000);
 /*if(plane.pState==DEAD1)
  Mix_FreeMusic(dead);
 if(plane.pState==ALIVE)*/
  Mix_FreeMusic(level1);
 return 0;
}
//checks for all collision, off screen items, etc
//I think most is self explanatory, every linklist is ran through
//and checked for anything that would make it be deleted
//I also have somewhat of an order, like off screen items first, then
//collision. 
void checkit(void)
{
  int shoot=0;
  Enemy *enemy, *eNext;
  Shot *shot, *sNext;

for (enemy = enemyFirst; enemy; enemy = eNext)
	{
      eNext = enemy->next;
	  if(enemy->eState==ENEMY_DEAD3){
    DrawIMG(back, enemy->iX-2, enemy->iY-2, 40, 35, enemy->iX-2, enemy->iY-2);
    eNext = enemy->next;
    UNLINK(enemy, enemyFirst, enemyLast);
	delete enemy;
	enemies--;}
  }

 for (Shot *pShot = pShotFirst, *psNext; pShot; pShot = psNext)
  {
    psNext = pShot->next;
  if (pShot->iY <= 0)
    {
		DrawIMG(back, pShot->iX-2, pShot->iY-2, 10, 10, pShot->iX-2, pShot->iY-2);
       UNLINK(pShot, pShotFirst, pShotLast);
        delete pShot; sos-=1;;
    }
  }
 
for (Shot *eShot = eShotFirst, *esNext; eShot; eShot = esNext)
  {
    esNext = eShot->next;
  if (eShot->iY >= 480)
    {
		DrawIMG(back, eShot->iX-2, eShot->iY-2, 10, 10, eShot->iX-2, eShot->iY-2);
       UNLINK(eShot, eShotFirst, eShotLast);
        delete eShot;
    }
  }

  for (enemy = enemyFirst; enemy; enemy = eNext)
	{
      eNext = enemy->next;
	  if (enemy->iY >= 480)
	  {
		  DrawIMG(back, enemy->iX-2, enemy->iY-2, 40, 40, enemy->iX-2, enemy->iY-2);
       UNLINK(enemy, enemyFirst, enemyLast);
        delete enemy;
		enemies--;
		if(plane.pState==ALIVE)
		   score-=5;
	  }
	  
	}

 for (shot = pShotFirst; shot; shot = sNext)
  {
    sNext = shot->next;

    for (enemy = enemyFirst; enemy; enemy = eNext)
	{
      eNext = enemy->next;

      if (shot->iX >= enemy->iX-9 && shot->iX <= enemy->iX+23 &&
        shot->iY >= enemy->iY-9 && shot->iY <= enemy->iY+9 && enemy->eState==ENEMY_ALIVE)
      {
        DrawIMG(back, shot->iX-2, shot->iY-2, 132, 132, shot->iX-2, shot->iY-2);
        UNLINK(shot, pShotFirst, pShotLast);
        delete shot; sos-=1;;

        enemy->iHealth -= 10;

        if (enemy->iHealth > 0)
          continue;
		enemy->eState=ENEMY_DEAD1;
		if(enemy->eState==ENEMY_DEAD3){
        DrawIMG(back, enemy->iX-2, enemy->iY-2, 40, 40, enemy->iX-2, enemy->iY-2);
		UNLINK(enemy, enemyFirst, enemyLast);
		delete enemy;
		enemies--;}
		score+=10;
	  }}}

  for (Shot *eShot = eShotFirst, *esNext; eShot; eShot = esNext)
  {
    esNext = eShot->next;
    if (plane.iX >= eShot->iX-29 && plane.iX <= eShot->iX &&
		plane.iY >= eShot->iY+2 && plane.iY <= eShot->iY+30 && plane.pState==ALIVE)
      {
		  DrawIMG(back, eShot->iX-2, eShot->iY-2, 10, 10, eShot->iX-2, eShot->iY-2);
		UNLINK(eShot, eShotFirst, eShotLast);
        delete eShot;plane.iHealth=plane.iHealth-5;
	  }
	  if (plane.iHealth<=0 && plane.lives==0 && plane.pState==ALIVE)
	   {
		   //Mix_FadeOutChannel(-1, 1000);
           //Mix_FadeOutMusic(1000);
           //SDL_Delay(1000);
           Mix_HaltMusic();
		   //level1 = Mix_LoadMUS("data/sound/tfplanet.xm");
		   plane.pState=DEAD1;

	   }
	  else if (plane.iHealth<=0 && plane.lives>0)
	  {
		  plane.lives--;
		  plane.iHealth=50;
	  }
  }

  for (enemy = enemyFirst; enemy; enemy = eNext)
	{
      eNext = enemy->next;
	  if (plane.iX >= enemy->iX-26 && plane.iX <= enemy->iX+20 &&
        plane.iY >= enemy->iY-26 && plane.iY <= enemy->iY+15 && plane.pState==ALIVE)
      {
		  DrawIMG(back, enemy->iX-2, enemy->iY-2, 132, 132, enemy->iX-2, enemy->iY-2);
		UNLINK(enemy, enemyFirst, enemyLast);
        delete enemy;
		enemies--;
	  }
	}

//this tests to see if the enemy shoots.
	for (enemy = enemyFirst; enemy; enemy = eNext)
	{
      eNext = enemy->next;
	  shoot = rand() % 1000;
    if (plane.iX >= enemy->iX-50 && plane.iX <= enemy->iX+45)
       {
	  if (shoot <= 30)
	  {
		  Shot *eNew;
	      eNew = new Shot;
          eNew->iX = enemy->iX+10;
          eNew->iY = enemy->iY+2;
		  LINK(eNew, eShotFirst, eShotLast);
	  }
	   }
	else
	{if (shoot <= 5)
	  {
		  Shot *eNew;
	      eNew = new Shot;
          eNew->iX = enemy->iX+10;
          eNew->iY = enemy->iY+2;
		  LINK(eNew, eShotFirst, eShotLast);
	  }}
	}
}

//Kill all linklists and make them empty, used for restarting and
//will probably be exit code too
void kill(void)
{
		Enemy *enemy, *eNext;
	    Shot *shot, *sNext;

        for (enemy = enemyFirst; enemy; enemy = eNext)
		 {
			eNext = enemy->next;
			DrawIMG(back, enemy->iX-2, enemy->iY-2, 132, 132, enemy->iX-2, enemy->iY-2);
			UNLINK(enemy, enemyFirst, enemyLast);
		    delete enemy;
			enemies--;
         }

 for (Shot *pShot = pShotFirst, *psNext; pShot; pShot = psNext)
  {
    psNext = pShot->next;
    UNLINK(pShot, pShotFirst, pShotLast);
    delete pShot;
	sos-=1;
  } 
 for (Shot *eShot = eShotFirst, *eNext; eShot; eShot = eNext)
  {
    eNext = eShot->next;
    UNLINK(eShot, eShotFirst, eShotLast);
    delete eShot;
  }
}

//but at the moment this is the exit code
void exit(void)
{
 Enemy *enemy, *eNext;
 Shot *shot, *sNext;

 for (Shot *pShot = pShotFirst, *psNext; pShot; pShot = psNext)
  {
    psNext = pShot->next;
    UNLINK(pShot, pShotFirst, pShotLast);
    delete pShot;
  } 
 for (Enemy *eTemp = enemyFirst, *eeNext; eTemp; eTemp = eeNext)
  {
    eeNext = eTemp->next;
    UNLINK(eTemp, enemyFirst, enemyLast);
    delete eTemp;
  }
 for (Shot *eShot = eShotFirst, *eNext; eShot; eShot = eNext)
  {
    eNext = eShot->next;
    UNLINK(eShot, eShotFirst, eShotLast);
    delete eShot;
  }
}

//this seems redundant, so I will probably just get rid of it
//right now I am not using it, I had a plan but I forgot what it was
//The code in here is basically the same as exit, and pretty much kill too
void gameover(void)
{
 Enemy *enemy, *eNext;
 Shot *shot, *sNext;
 
 for (Shot *pShot = pShotFirst, *psNext; pShot; pShot = psNext)
  {
    psNext = pShot->next;
    UNLINK(pShot, pShotFirst, pShotLast);
    delete pShot;
  } 
 for (Enemy *eTemp = enemyFirst, *eeNext; eTemp; eTemp = eeNext)
  {
    eeNext = eTemp->next;
    UNLINK(eTemp, enemyFirst, enemyLast);
    delete eTemp;
  }
 for (Shot *eShot = eShotFirst, *eNext; eShot; eShot = eNext)
  {
    eNext = eShot->next;
    UNLINK(eShot, eShotFirst, eShotLast);
    delete eShot;
  }
}